更新：2018-04-14  
> 说明：这里所列举的学习手册主要是迁移学习在深度学习上的应用。对于迁移学习大局了解
可参考[这里](https://github.com/jindongwang/transferlearning-tutorial)   


{Todo}学者部分：  [链接](https://github.com/jindongwang/transferlearning/blob/master/doc/scholar_TL.md)


参考文献：  
[1] 王晋东.迁移学习简明手册[[pdf-v1.0]](http://jd92.wang/assets/files/transfer_learning_tutorial_wjd.pdf),
[Github](https://github.com/jindongwang/transferlearning-tutorial/tree/master)    

一些推荐阅读文章：  


#### 1. 迁移学习概念   
迁移学习的核心问题是，找到新问题和原问题之间的相似性，才可以顺利实现知识的迁移。也即生活中“举一反三”。  
> 定义：迁移学习，是指利用数据、任务、或模型之间的相似性，将在旧领域学习过的模型，应用于新领域的一种学习过程。  
`为什么需要迁移学习呢？`   
可以归结为以下四点，即`迁移学习`为主要解决以下四个问题：

* `大数据与少标注之间的矛盾`。虽然目前都提倡通过 AI 去解决问题，而且目前处在大数据时代，数据都比较容易获取到。然而，对于这种获取到数据是没有标注。然而，机器学习模型的训练和更新均起来数据标注。  
>利用迁移学习的思想，我们可以寻找一些与数据来构建模型，增加我们目标数据的标注。

* `大数据与弱计算之间的矛盾`。即便对于拥有大数据，但对于目前而言，大数据下的计算力也是不可或缺的。然而，对于一个好的 Net 都需要经过漫长时间训练才能获得较好的模型参数。    
> 利用迁移学习的思想，我们可以将那些大公司在大数据上训练好的模型，迁移到我们的任务中。针对于我们的任务进行微调，从而我们也可以拥有在大数据上训练好的模型。更进一步，我们可以将这些模型针对我们的任务进行自适应更新，从而取得更好的效果。

* `普适化模型与个性化需求之间的矛盾`。虽说机器学习的目标是用来构建尽可能通用的模型，提供整体的泛化能力，然而现在却是始终不能彻底解决的。与之同时，个性化的需求也使得同一个模型不能专门性针对个性用户需求。  
> 我们利用迁移学习的思想，进行自适应的学习。考虑到不同用户之间的相似性和差异性，我们对普适化模型进行灵活的调整，以便完成我们的任务。

* `特定应用的需求`。在这些应用中，也存在着一些特定的应用，它们面临着一些现实存在的问题。  
> 我们可以利用上述介绍过的手段，从数据和模型方法上进行迁移学习   

**负迁移**   
虽然我们都希望迁移学习能够顺利记性，但是事情本身可能并不会是那么顺利。这里有的时候，使用源领域和目标领域不存在关联，这里将导致预测结果变得十分差。>迁移学习指的是，利用数据和领域之间存在的相似性关系，把之前学习到的知识，应用于新的未知领域。迁移学习的核心问题是，找到两个领域的相似性。找到了这个相似性，就可以合理地利用，从而很好地完成迁移学习任务。  
产生负迁移的原因主要有：   
* 数据问题：源域和目标域完全不相似   
* 方法问题：源域和目标域存在相似，但是迁移方法不够好，或者说没有找到迁移的成分。  
负迁移给迁移学习的研究和应用带来了负面影响。在实际应用中，找到合理的相似性，并且选择或开发合理的迁移学习方法，能够避免负迁移现象。   

#### 2.迁移学习的研究领域  
按照目标领域   
1. 监督迁移学习(Supervised Transfer Learning)
2. 半监督迁移学习(Semi-Supervised Transfer Learning)
3. 无监督迁移学习(Unsupervised Transfer Learning)   

按照学习方法  
1. 基于样本的迁移学习方法(Instance based Transfer Learning)
2. 基于特征的迁移学习方法(Feature based Transfer Learning)
3. 基于模型的迁移学习方法(Model based Transfer Learning)
4. 基于关系的迁移学习方法(Relation based Transfer Learning)   

按照特征分类  
1. 同构迁移学习(Homogeneous Transfer Learning)
2. 异构迁移学习(Heterogeneous Transfer Learning)  

按照离线和在线形式分  
1. 离线迁移学习(Offline Transfer Learning)
2. 在线迁移学习(Online Transfer Learning)   

#### 3.迁移学习的应用
1. 计算机视觉     
计算机这边的迁移就相对比较多，可以做微小变化去自适应不同环境下需求。当然，对于迁移学习十分重要的是学习的鲁棒性。
2. 文本分类   
同理，对于不同文本之间迁移学习。
3. 时间序列   
行为识别？
4. 医疗健康   
个人觉得，在医疗健康，迁移学习将发挥其很大作用，但也应当注意到医疗方面目标域的数据分布问题。


#### 4.深度迁移学习   
> 这里只做深度学习相关的学习内容。当然这里也直接跳过了一些理论基本，这是不应该的。{Todo} 希望今后加上。  

为什么深度网络可以迁移？  
* 神经网络实际一种特殊的特征提取器   

1. `深度网络自适应`   
相信很多都知道`finetune`可以帮助我们节省很多时间，并提高精度，然而，我们忽略一个事实：`finetune`基本假设是训练数据和测试数据服从同一分布。对于不同分布的数据，实际 finetune 往往效果是不好的。因此，更好的方式是做到深度网络自适应。该方式主要完成：
* 哪些层可以自适应，这决定网络的学习程度；   
* 采用什么样的自适应方法（度量原则），这决定网络的泛化能力  
核心方法：`DDC`、`DAN`、`同时迁移领域和任务`、`深度联合分布自适应`、`AdaBN`   

2. `深度对抗网络迁移` 
核心方法：`DANN`、`DSN`、`SAN`







#### 前沿   
* 机器智能与人类经验结合迁移  
* 传递迁移学习 `Transitive transfer learning `  
* 远领域迁移学习 `Distant domain transfer learning `  
* 终身迁移学习   
* 在线迁移学习  
* 迁移强化学习
* 迁移学习的可解释性 











