## 深度学习相关

深度学习路线图框架  
1 深度学习历史和基础  
* 1.0 书籍  
* 1.1 调查  
* 1.2 深度信念网络（DBN）（深度学习里程碑）  
* 1.3 ImageNet 演变（深度学习突破点）
* 1.4 语音识别的演变  
 
2 深度学习  
* 2.1 模型   
* 2.2 优化  
* 2.3 无监督学习/深度生成模型   
* 2.4 循环神经网络 / 序列模型  
* 2.5 神经图灵机  
* 2.6 深度强化学习  
* 2.7 深度迁移学习 /终身学习 /  
* 2.8 一次学习（深度学习）   

3 应用  
* 3.1 自然语言处理（NLP）  
* 3.2 物体检测  
* 3.3 视觉追踪  
* 3.4 看图说话  
* 3.5 机器翻译  
* 3.6 机器人技术  
* 3.7 艺术方面  
* 3.8 对象分割   


###  1.流行的CNN框架  
* LetNet-5 [pdf][pdf-0.1]
* AlexNet [pdf][pdf-0.2]
* VGGNet  [pdf][pdf-0.3]
* GoogLeNet [pdf][pdf-0.4]
* ResNet  [pdf][pdf-0.5]



### 2.目标检测与物体识别
* 物体检测：
> 基于CNN检测器分为两类：一类，[SSD](https://arxiv.org/abs/1512.02325)、[YOLO](https://arxiv.org/abs/1506.02640)、[Retina-
Net](https://arxiv.org/abs/1708.02002)，另一类为，[Faster R-CNN](https://arxiv.org/abs/1506.01497)、[R-FCN](https://arxiv.org/abs/1605.06409)
和 [Mask-RCNN](https://arxiv.org/abs/1703.06870).  

综述性文章：  
[1]. [卷积神经网络在图像分类和目标检测应用综述](https://drive.google.com/open?id=1BOSOFxRpTCF59OIUtZeLQh9bjZAUeyJr)


* 迁移学习
> [迁移学习资料汇总](https://github.com/jindongwang/transferlearning)

其他：
>   这里放的是学习的resource  
个人学习深度学习更新放在[这里](hhttps://github.com/PeterChenYijie/DeepLearningZeroToALL)
focus在自己做项目以及学习上的一些学习



---
[pdf-0.1]:http://yann.lecun.com/exdb/publis/pdf/lecun-89e.pdf
[pdf-0.2]: http://papers.nips.cc/paper/4824-imagenet-classification-with-deep-convolutional-neural-networks.pdf 
[pdf-0.3]: https://arxiv.org/pdf/1409.1556.pdf
[pdf-0.4]: http://www.cv-foundation.org/openaccess/content_cvpr_2015/papers/Szegedy_Going_Deeper_With_2015_CVPR_paper.pdf
[pdf-0.5]: https://arxiv.org/pdf/1512.03385.pdf