## 添加图像处理
对于图像的理解，首推冈萨雷斯的《数字图像处理》  

 CV 算法主要有 5 个步骤：`特征感知`、`图像预处理`、`特征提取`、`特征筛选`、`推理预测与识别`

对于想要了解图像处理，首先应当对图像的形成有一定的认知和了解。这里主要对的是相机成像内容，
其他例如`X射线成像`、`紫外,红外波段成像`、`声学成像`、`微波`、`无线电`等需要后期更新。   
总结内容主要有：
> * [图像成像原理]
> * CMOS 和 CCD 的区别
> * RGB 以及对应相关的转换
> * 图像噪声产生的原因  

对于图像处理需要更多在数学上的理解，而不是只是应用层。主要要理解:
> * 像素的操作、通道分离和合并
> * 直方图
> * 膨胀、腐蚀、开运算、闭运算
> * 基本滤波、Sobel 算子、拉普拉斯算子，Canny 算子
> * 轮廓检测  

补充  
**特征提取**


图像成像原理
> 应当了解数字图像感知部件：物体设备（该设备对我们希望成像物体发射的能量很敏感）、数字化器件
（将物理感知装置的输出转化为数字形式）。对于数字视频摄像机，其通过传感器（与光强成比例输出）得到模拟信号，
再通过数字转换器进行数字化格式输出，当然这种形式下得到的图像只是灰度图片。关于如何得到彩色图片呢以及目前数码照片
是怎么得到呢？这里需要两个概念：滤波片以及拜尔阵列。通俗的解释参见
[通俗理解 相机成像:拜尔与上帝的对话](http://bbs.fengniao.com/forum/3055346.html)

CMOS 和 CCD
> [链接](http://www.elecfans.com/d/616475.html)

> 目前相机的图像传感器主要是 `CMOS` 和 `CCD` ，或者说未来可能出现新的一种图像传感器？对于这两种图像传感器应当明白其原理以及
两者之间的优缺点。


>简单而言，`CCD` 效果很好（成像质量高、灵敏度高、噪声低、响应速度快，图像即便小，无残像、像素集成度也高），但是成本太高；
相比， `CMOS` 读取信息简单，输出信息速率快，耗电小、体积小、重点轻，关键还是便宜。

