# 人工智能相关术语（按首字母排序）
其他：[218个机器学习术语词汇表（收藏）](http://blog.csdn.net/t7sfokzord1jaymsfk4/article/details/79320071)


缩写|英语|汉语
-----|-----|-----
  |**A**|
  |Activation Function|激活函数
  |Adversarial Networks|对抗网络
  |Affine Layer|仿射层
  |agent|代理/智能体
  |algorithm|算法
  |alpha-beta pruning|α-β剪枝
  |anomaly detection|异常检测
  |approximation|近似
AGI|Artificial General Intelligence|通用人工智能
AI|Artificial Intelligence|人工智能
  |association analysis|关联分析
  |attention mechanism|注意机制
  |autoencoder|自编码器
ASR|automatic speech recognition|自动语音识别
  |automatic summarization|自动摘要
  |average gradient|平均梯度
  |Average-Pooling|平均池化
  |**B**|
BP|backpropagation|反向传播
BPTT|Backpropagation Through Time|通过时间的反向传播
BN|Batch Normalization|分批标准化
  |Bayesian network|贝叶斯网络
  |Bias-Variance Dilemma|偏差/方差困境
Bi-LSTM|Bi-directional Long-Short Term Memory|双向长短期记忆
  |bias|偏置/偏差
  |big data|大数据
  |Boltzmann machine|玻尔兹曼机
  |**C**|
CPU|Central Processing Unit|中央处理器
  |chunk|词块
  |clustering|聚类
  |cluster analysis|聚类分析
  |co-adapting|共适应
  |co-occurrence|共现
  |Computation Cost|计算成本
  |Computational Linguistics|计算语言学
  |computer vision|计算机视觉
  |concept drift|概念漂移
CRF|conditional random field|条件随机域/场
  |convergence|收敛
CA|conversational agent|会话代理
  |convexity|凸性
CNN|convolutional neural network|卷积神经网络
  |Cost Function|成本函数
  |cross entropy|交叉熵
  |**D**|
  |Decision Boundary|决策边界
  |Decision Trees|决策树
DBN|Deep Belief Network|深度信念网络
[DCGAN](https://arxiv.org/abs/1511.06434)|Deep Convolutional Generative Adversarial Network|深度卷积生成对抗网络
DL|deep learning|深度学习
DNN|deep neural network|深度神经网络
  |Deep Q-Learning|深度Q学习
DQN|Deep Q-Network|深度Q网络
[DNC](http://www.nature.com/nature/journal/v538/n7626/full/nature20101.html)|differentiable neural computer|可微分神经计算机
  |dimensionality reduction algorithm|降维算法
  |discriminative model|判别模型
  |discriminator|判别器
  |divergence|散度
  |domain adaption|领域自适应
  |Dropout|
  |Dynamic Fusion|动态融合
  |**E**|
  |Embedding|嵌入
  |emotional analysis|情绪分析
  |End-to-End|端到端
EM|Expectation-Maximization|期望最大化
  |Exploding Gradient Problem|梯度爆炸问题
[ELM](http://axon.cs.byu.edu/~martinez/classes/678/Presentations/Yao.pdf)|Extreme Learning Machine|超限学习机
  |**F**|
[FAIR](https://research.facebook.com/ai)|Facebook Artificial Intelligence Research|Facebook人工智能研究所
  |factorization|因子分解
  |feature engineering| 特征工程
  |Featured Learning|特征学习
  |Feedforward Neural Networks|前馈神经网络
  |**G**|
  |game theory|博弈论
GMM|Gaussian Mixture Model|高斯混合模型
GA|Genetic Algorithm|遗传算法
  |Generalization|泛化
[GAN](https://arxiv.org/abs/1406.2661)|Generative Adversarial Networks|生成对抗网络
  |Generative Model|生成模型
  |Generator|生成器
  |Global Optimization|全局优化
[GNMT](https://arxiv.org/abs/1609.08144)|Google Neural Machine Translation|谷歌神经机器翻译
  |Gradient Descent|梯度下降
  |graph theory|图论
GPU|graphics processing unit|图形处理单元/图形处理器
  |**H**|
HDM|hidden dynamic model|隐动态模型
  |hidden layer|隐藏层
HMM|Hidden Markov Model|隐马尔可夫模型
  |hybrid computing|混合计算
  |hyperparameter|超参数
  |**I**|
ICA|Independent Component Analysis|独立成分分析
  |input|输入
[ICML](http://icml.cc/)|International Conference for Machine Learning|国际机器学习大会
  |language phenomena|语言现象
  |latent dirichlet allocation|隐含狄利克雷分布
  |**J**|
JSD|Jensen-Shannon Divergence|JS距离
  |**K**|
  |K-Means Clustering|K-均值聚类
K-NN|K-Nearest Neighbours Algorithm|K-最近邻算法
  |Knowledge Representation|知识表征
KB|knowledge base|知识库
  |**L**|
  |Latent Dirichlet Allocation|隐狄利克雷分布
LSA|latent semantic analysis| 潜在语义分析
  |learner|学习器
  |Linear Regression|线性回归
  |log likelihood|对数似然
  |Logistic Regression|Logistic回归
[LSTM](http://deeplearning.cs.cmu.edu/pdfs/Hochreiter97_lstm.pdf)|Long-Short Term Memory|长短期记忆
  |loss|损失
  |**M**|
MT|machine translation|机器翻译
  |Max-Pooling|最大池化
  |Maximum Likelihood|最大似然
  |minimax game|最小最大博弈
  |Momentum|动量
MLP|Multilayer Perceptron|多层感知器
  |multi-document summarization|多文档摘要
MLP|multi layered perceptron|多层感知器
  |multimodal learning|多模态学习
  |multiple linear regression|多元线性回归
  |**N**|
  |Naive Bayes Classifier|朴素贝叶斯分类器
  |named entity recognition|命名实体识别
  |Nash equilibrium|纳什均衡
NLG|natural language generation|自然语言生成
NLP|natural language processing	|自然语言处理
NLL|Negative Log Likelihood|负对数似然
NMT|Neural Machine Translation|神经机器翻译
NTM|Neural Turing Machine|神经图灵机
NCE|noise-contrastive estimation|噪音对比估计
  |non-convex optimization|非凸优化
  |non-negative matrix factorization|非负矩阵分解
  |Non-Saturating Game|非饱和博弈
  |**O**|
  |objective function|目标函数
  |Off-Policy|离策略
  |On-Policy|在策略
  |one shot learning|一次性学习
  |output|输出
  |**P**|
  |Parameter|参数
  |parse tree|解析树
  |part-of-speech tagging|词性标注
PSO|Particle Swarm Optimization|粒子群优化算法
  |perceptron|感知器
  |polarity detection|极性检测
  |pooling|池化
[PPGN](https://arxiv.org/abs/1612.00005)|Plug and Play Generative Network|即插即用生成网络
PCA|principal component analysis|主成分分析
  |Probability Graphical Model|概率图模型
  |**Q**|
[QNN](https://arxiv.org/abs/1609.07061)|Quantized Neural Network|量子化神经网络
  |quantum computer|量子计算机
  |Quantum Computing|量子计算
  |**R**|
RBF|Radial Basis Function|径向基函数
  |Random Forest Algorithm|随机森林算法
ReLU|Rectified Linear Unit|线性修正单元/线性修正函数
RNN|Recurrent Neural Network|循环神经网络
  |recursive neural network|递归神经网络
RL|reinforcement learning|强化学习
  |representation|表征
  |representation learning|表征学习
  |Residual Mapping|残差映射
  |Residual Network|残差网络
RBM|Restricted Boltzmann Machine|受限玻尔兹曼机
  |Robot|机器人
  |Robustness|稳健性
RE|Rule Engine|规则引擎
  |**S**|
  |saddle point|鞍点
  |Self-Driving|自动驾驶
SOM|self organised map|自组织映射
  |Semi-Supervised Learning|半监督学习
  |sentiment analysis| 情感分析
SLAM|simultaneous localization and mapping|同步定位与地图构建
SVD|Singular Value Decomposition|奇异值分解
  |Spectral Clustering|谱聚类
  |Speech Recognition|语音识别
SGD|stochastic gradient descent| 随机梯度下降
  |supervised learning|监督学习
SVM|Support Vector Machine|支持向量机
  |synset|同义词集
  |**T**|
t-SNE|T-Distribution Stochastic Neighbour Embedding|T-分布随机近邻嵌入
  |tensor|张量
TPU|Tensor Processing Units|张量处理单元
  |the least square method|最小二乘法
  |Threshold|阙值
  |Time Step|时间步骤
  |tokenization|标记化
  |treebank|树库
  |transfer learning|迁移学习
  |Turing Machine|图灵机
  |**U**|
  |unsupervised learning|无监督学习
  |**V**|
  |Vanishing Gradient Problem|梯度消失问题
VC Theory|Vapnik–Chervonenkis theory|万普尼克-泽范兰杰斯理论
  |von Neumann architecture|冯·诺伊曼架构/结构
  |**W**|
[WGAN](https://arxiv.org/abs/1701.07875)|Wasserstein GAN|
W|weight|权重
  |word embedding|词嵌入
WSD|word sense disambiguation|词义消歧
  |**X**|
  |**Y**|
  |**Z**|
ZSL|zero-shot learning|零次学习
  |zero-data learning|零数据学习
  |**0**|
