# 动手学习 DeepLearning
[![MIT license](https://img.shields.io/dub/l/vibe-d.svg)](https://github.com/PeterChenYijie/DeepLearningZeroToALL/blob/master/LICENSE)

# 从0到1学习深度学习
对于初学者，我建议先参考这些github项目:   
* TensorFlow:[TensorFlow Basic Tutorial Labs](https://github.com/hunkim/DeepLearningZeroToAll)
* MXNet:[gluon-tutorials-zh](https://github.com/mli/gluon-tutorials-zh)
* PyTorch:[PyTorch-tutorial](https://github.com/yunjey/pytorch-tutorial)、
[code-of-learn-deep-learning-with-pytorch](https://github.com/SherlockLiao/code-of-learn-deep-learning-with-pytorch)
* PaddlePaddle:[Quick Start](http://www.paddlepaddle.org/docs/develop/documentation/zh/getstarted/quickstart_cn.html)

本工程建立用来记录个人深度学习的过程。当然，在整个学习过程中，将尝试用不同的深度学习框架来进行学习。以便提供更多学习范例。  
目录大致分为：
* 深度学习基础
* 深度学习的初步学习教程 
    * [TensorFlow](Basic-Tutorial/TensorFlow)  
    * [MXNet](Basic-Tutorial/MXNet/gluon-basics)
    * [PyTorch](Basic-Tutorial/PyTorch/)
    * [PaddlePaddle](Basic-Tutorial/PaddlePaddle)
* [笔记](Note)     
* [计算机视觉](Computer-vision)
* [自然语言处理](Natural-language-processing)
* [其他](Extra)

这个项目还是进行中，仍旧需要大伙共同协助完成。我们希望得到你的推送，这里我们有一些提醒：

> * 详细描述使用框架、比赛内容，用户（如@Zhangsan cifar10-tensorflow）  
> * 不必放你自己的数据(创建你自己的一个连接分享就好)                   
> * 为更好确保你的工程能够为人所用，写一个 requirement.txt 和readme.md

最后，希望大家能够积极踊跃参与！  

一些链接: 
* [吴恩达 Coursera 深度学习 代码](https://github.com/Kulbear/deep-learning-coursera)   
* [深度学习阅读路线图](https://github.com/songrotek/Deep-Learning-Papers-Reading-Roadmap)
`论文pdf`：百度网盘[链接](https://pan.baidu.com/s/1ghgvowr)
* [中文文案排版指北（简体中文版）](Copywriting%20Guidelines.md)
* [专业术语 updating](Note/terminology.md)   


> *** [声明]此仓库是我开源到Github上的，可以遵守相关的开源协议进行使用。这个仓库中包含有很多研究者的论文、硕博士论文以及Github其他作者的开源仓库等都来源于在网上的下载，仅作为学术研究使用。如果作者或出版社有异议，请联系我进行删除。一切都是为了更好地学术！***



# Learn DeepLearning from Zero to One

For newer,I strongly recommend to read the following GitHub project:  
* TensorFlow:[TensorFlow Basic Tutorial Labs](https://github.com/hunkim/DeepLearningZeroToAll)
* MXNet:[gluon-tutorials-zh](https://github.com/mli/gluon-tutorials-zh)
* PyTorch:[PyTorch-tutorial](https://github.com/yunjey/pytorch-tutorial)、
[code-of-learn-deep-learning-with-pytorch](https://github.com/SherlockLiao/code-of-learn-deep-learning-with-pytorch)
* PaddlePaddle:[Quick Start](http://www.paddlepaddle.org/docs/develop/documentation/zh/getstarted/quickstart_cn.html)




This project is built to record personal DeepLearning process.Of course,during the process,I will try to use some 
different frame to learn for providing more remarkable examples.  
The Table will be listed on:
* basic of DeepLearning
* tutorial
    * [TensorFlow](Basic-Tutorial/TensorFlow) 
    * [MXNet](Basic-Tutorial/MXNet/gluon-basics)
    * [PyTorch](Basic-Tutorial/PyTorch) 
    * [PaddlePaddle](Basic-Tutorial/PaddlePaddle)
* [note](Note)
* [CV](Computer-vision)
* [NLP](Natural-language-processing)
* [extra](Extra)

This project is still ongoing,I hope more guys can join it and push your State-Of-Art code.Before you push,I hope you can read those guides:
> * describe frame,content,user(such @ZhangSan cifar-10-tensorflow)
> * Not need to put your own data (just use links to share the data)
> * Better to write requirement.txt and readme.md 

Some Links:    
* [Deep Learning Papers Reading Roadmap](https://github.com/songrotek/Deep-Learning-Papers-Reading-Roadmap)
* [English Copywriting Guidelines](Copywriting%20Guidelines.en.md)
* [Terminology updating](Note/terminology.md)
